-- read c:/mg/civstat/ocl-bench-core/abcde.cmd

open c:/mg/civstat/ocl-bench-core/civstat.use

!create ada:Person

-- !openter ada birth('Ada','female')

!set ada.name:='Ada'
!set ada.civstat:='single'
!set ada.gender:='female'
!set ada.alive:=true

!create bob:Person

-- !openter bob birth('Bob','male')

!set bob.name:='Bob'
!set bob.civstat:='single'
!set bob.gender:='male'
!set bob.alive:=true

-- !openter ada marry(bob)

!set ada.civstat:='married'
!set bob.civstat:='married'
!insert (ada,bob) into Marriage

!create cyd:Person

-- !openter cyd birth('Cyd','male')

!set cyd.name:='Cyd'
!set cyd.civstat:='single'
!set cyd.gender:='male'
!set cyd.alive:=true

-- !openter ada divorce()

!set ada.civstat:='divorced'
!set bob.civstat:='divorced'
!delete (ada,bob) from Marriage

-- !openter cyd marry(ada)

!set cyd.civstat:='married'
!set ada.civstat:='married'
!insert (ada,cyd) into Marriage

!create dan:Person

-- !openter dan birth('Dan','male')

!set dan.name:='Dan'
!set dan.civstat:='single'
!set dan.gender:='male'
!set dan.alive:=true

-- !openter cyd death()

!set cyd.alive:=false
!set ada.civstat:='widowed'
!delete (ada,cyd) from Marriage

!create eve:Person

-- !openter eve birth('Eve','female')

!set eve.name:='Eve'
!set eve.civstat:='single'
!set eve.gender:='female'
!set eve.alive:=true

-- !openter dan marry(eve)

!set dan.civstat:='married'
!set eve.civstat:='married'
!insert (eve,dan) into Marriage

------------------------------------------------------------------------

?Set{ada,bob,cyd}->collect(p:Person|p.name)

------------------------------------------------------------------------

?Set{ada,bob,cyd}.name=Bag{'Ada','Bob','Cyd'}

------------------------------------------------------------------------

?Set{ada,bob,cyd}->collectNested(p:Person|Sequence{p.name,p.civstat,p.gender,p.alive})

------------------------------------------------------------------------

?Person.allInstances->select(p:Person|p.husband=Person.allInstances->any(p:Person|p.wife->isEmpty()).wife).name

------------------------------------------------------------------------

?Person.allInstances->forAll(p1,p2:Person|p1<>p2 implies p1.name<>p2.name)

------------------------------------------------------------------------

?Person.allInstances->isUnique(p:Person|p.name)

------------------------------------------------------------------------

?Person.allInstances->forAll(p:Person|(p.gender='female' implies p.wife->isEmpty) and (p.gender='male' implies p.husband->isEmpty))

------------------------------------------------------------------------

?Person.allInstances->select(p:Person|p.alive and p.civstat<>'widowed').civstat

------------------------------------------------------------------------

?let o:OclAny=ada in o

------------------------------------------------------------------------

?Person.allInstances->iterate(w,h:Person;res:Set(Tuple(bride:Person,bridegroom:Person))=oclEmpty(Set(Tuple(bride:Person,bridegroom:Person)))|if w.gender='female' and h.gender='male' and w.alive and h.alive and w.civstat<>'married' and h.civstat<>'married' then res->including(Tuple{bride:w,bridegroom:h}) else res endif)

------------------------------------------------------------------------

?Set{Bag{eve},Bag{eve.spouse()},Bag{eve.spouse().spouse()},Bag{eve.spouse().spouse().spouse()},Bag{eve.spouse().spouse().spouse().spouse()},Bag{eve.spouse().spouse().spouse().spouse().spouse()}}->flatten()

------------------------------------------------------------------------

check
