-- Collection Operations

-- -- Iterate

-- -- -- collect

-- -- -- -- Empty

-- -- -- -- -- Set -----------------------------------------------------

?let c = oclEmpty(Set(Integer)) in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- Sequence A

?let c = oclEmpty(Sequence(Integer)) in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- Sequence B

?let c = oclEmpty(Sequence(Integer)) in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence A

?let c = Sequence{oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence B

?let c = Sequence{oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{2} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Bag

?let c = Bag{2} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence A

?let c = Sequence{2} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence B

?let c = Sequence{2} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer), 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 0, 1, 2, oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence A

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2, oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence B

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2, oclUndefined(Integer)} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{-1, 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{-1, 0, 1, 2, 1} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{-1, 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Bag(Integer) = oclEmpty(Bag(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence A

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{-1, 0, 1, 2, 1} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{-1, 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(i*i))

-- -- -- -- -- -- Sequence B

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{-1, 0, 1, 2, 1} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{-1, 0, 1, 2} in c->collect(i|i*i) = c->iterate(i;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->append(i*i))
