-- Technical Relationships

-- -- iterate with let

-- -- -- Empty

-- -- -- -- Set ---------------------------------------------------

?let c = oclEmpty(Set(Integer)) in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- Singleton

-- -- -- -- Includes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{oclUndefined(Integer)} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- Excludes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{2} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = Bag{2} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = Sequence{2} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- Many Elements

-- -- -- -- Includes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{oclUndefined(Integer), 2, 3, -10} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

-- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 2, 3, -10, 
                  oclUndefined(Integer)} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 2, 3, -10} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

-- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 2, 3, -10, 
                       oclUndefined(Integer)} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 2, 3, -10} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- Excludes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{1, 2, 3, -10} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

-- -- -- -- -- -- Equal Values

?let c = Bag{1, 2, 3, -10, 1} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 3, -10} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

-- -- -- -- -- -- Equal Values

?let c = Sequence{1, 2, 3, -10, 1} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean

-- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 3, -10} in 
   c->iterate(elem; r:Bag(Integer) = Bag{1} | 
         r->including(r->size()+elem)) 
       = 
   c->iterate(elem; r:Bag(Integer) = Bag{1} |
         let res = r->including(r->size()+elem) in res)

Expected Results:
  true : Boolean
