-- read c:/mg/bmark/efficiency/datatypes.cmd

-- Build truth tables for boolean connectives
-- 16 -> 1024

?Sequence{1..16}->iterate(i:Integer;res:Sequence(Sequence(Boolean))=Set{false,true,oclUndefined(Boolean)}->iterate(b1,b2:Boolean;res:Sequence(Sequence(Boolean))=oclEmpty(Sequence(Sequence(Boolean)))|res->including(Sequence{b1,b2,not(b1),b1 and b2,b1 or b2,b1 xor b2,b1 implies b2,b1=b2,b1<>b2}))|res)

-- Invert a long string
-- base: base string consisting of digits, small and capital letters
-- count: determining a repition number
-- longstr: a long string in which the base string is repeated
-- return expression inverts longstr
-- 16 -> 1024

\
?let base:String='0123456789'.concat('abcdefghijklmnopqrstuvwxyz').
       concat('ABCDEFGHIJKLMNOPQRSTUVWXYZ') in
 let count:Integer=16 in
 let longstr:String=Set{1..count}->iterate(
       i:Integer;res:String=''|res.concat(base)) in
 Set{1..longstr.size()}->iterate(i:Integer;res:String=''|
   res.concat(longstr.substring(longstr.size()+1-i,longstr.size()+1-i)))
.

open c:/mg/bmark/efficiency/datatypes.use
!create m:MathLib

-- Compute all prime numbers up to a given upper bound
-- 16 -> 2048

\
?Sequence{1..2048}->iterate(i:Integer;
  res:Sequence(Integer)=oclEmpty(Sequence(Integer))|
    if m.isPrime(i) then res->including(i) else res endif)
.

?Sequence{1..16}->iterate(i;res:Sequence(Sequence(OclAny))=oclEmpty(Sequence(Sequence(OclAny)))|res->including(Sequence{i,m.isPrime(i)}))->select(s|s->last()=true)

-- Compute the root of 10.89 with precision 1/10^16
-- 16 -> 1024*1024

\
?Set{1..16}->iterate(i;res:Real=
  m.root(10.89,1/(10*10*10*10*10*10*10*10*10*10*10*10*10*10*10*10))|res)
.

-- USE and Java are already bad in computing 3.3*3.3=10.89
?3.3*3.3
