-- Collection Operations

-- -- DB related

-- -- -- select to reject

-- -- -- -- Empty

-- -- -- -- -- Set -----------------------------------------------------

?let c = oclEmpty(Set(Integer)) in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer)} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Bag

?let c = Bag{1} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Sequence

?let c = Sequence{1} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{4} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Bag

?let c = Bag{4} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Sequence

?let c = Sequence{4} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer), 1, 2, 3} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, 2, 3, oclUndefined(Integer)} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, 2, 3} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 2, 3, oclUndefined(Integer)} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 2, 3} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1, 2, 3} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values

?let c = Bag{1, 2, 3, 1} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 3} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values

?let c = Sequence{1, 2, 3, 1} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 3} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{2, 3, 4, 5} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Bag{2, 3, 4, 5, 4} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Bag{2, 3, 4, 5, 2} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{2, 3, 4, 5} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Sequence{2, 3, 4, 5, 4} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Sequence{2, 3, 4, 5, 2} in c->select(i|i<4) = c->reject(i|not(i<4))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{2, 3, 4, 5} in c->select(i|i<4) = c->reject(i|not(i<4))
