-- Collection Operations

-- -- Interdisciplinary

-- -- -- exists to reject

-- -- -- -- Empty

-- -- -- -- -- Set ------------------------------------------------

?let c = oclEmpty(Set(Integer)) in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer)} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

?let c = Bag{1} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

?let c = Sequence{1} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

?let c = Bag{4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

?let c = Sequence{4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer), 2, 3, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 2, 3, 4, 
                  oclUndefined(Integer)} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 2, 3, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 2, 3, 4, 
                       oclUndefined(Integer)} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 2, 3, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1, 2, 3, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values

?let c = Bag{1, 2, 3, 4, 1} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 3, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values

?let c = Sequence{1, 2, 3, 4, 1} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 3, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{4, 5, 6} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Bag{4, 5, 6, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{4, 5, 6} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Sequence{4, 5, 6, 4} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{4, 5, 6} in
   c->exists(i|i<4) = c->reject(i|i<4)->size()<c->size()

Expected Results:
  true : Boolean
