-- Collection Operations

-- -- Interdisciplinary

-- -- -- one to select

-- -- -- -- Empty

-- -- -- -- -- Set -----------------------------------------------------

?let c = oclEmpty(Set(Integer)) in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)
 
-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer)} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Bag

?let c = Bag{1} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Sequence

?let c = Sequence{1} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{4} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Bag

?let c = Bag{4} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Sequence

?let c = Sequence{4} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer), 1, 4, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, 4, 5, oclUndefined(Integer)} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, 4, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values 

?let c = Sequence{oclUndefined(Integer), 1, 4, 5, oclUndefined(Integer)} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 4, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1, 4, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values

?let c = Bag{1, 4, 5, 4} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 4, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values

?let c = Sequence{1, 4, 5, 4} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 4, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1, 2, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values (violating)

?let c = Bag{1, 2, 5, 1} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- -- Equal Values (not violating)

?let c = Bag{1, 2, 5, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Sequence{1, 2, 5, 1} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Sequence{1, 2, 5, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 5} in c->one(i|i<4) = (c->select(i|i<4)->size() = 1)

