-- Collection Operations

-- -- Collect

-- -- -- forAll to collect and one

-- -- -- -- Empty

-- -- -- -- -- Set -----------------------------------------------------

?let c = oclEmpty(Set(Integer)) in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer)} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Bag

?let c = Bag{1} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Sequence

?let c = Sequence{1} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------------

?let c = Set{4} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Bag

?let c = Bag{4} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Sequence

?let c = Sequence{4} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer), 1, 2, 3} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, 2, 3, oclUndefined(Integer)} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, 2, 3} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 2, 3, oclUndefined(Integer)} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 2, 3} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1, 2, 3} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values

?let c = Bag{1, 2, 3, 1} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 3} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values 

?let c = Sequence{1, 2, 3, 1} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 3} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{2, 3, 4, 5} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Bag{2, 3, 4, 5, 4} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Bag{2, 3, 4, 5, 2} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{2, 3, 4, 5} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Sequence{2, 3, 4, 5, 4} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Sequence{2, 3, 4, 5, 2} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{2, 3, 4, 5} in c->forAll(i|i<4) = (let s = c->collect(i|i<4)->asSet() in c->notEmpty() implies s->one(true) and s->one(e|e))

