-- Collection Operations

-- -- Iterate

-- -- -- forAll

-- -- -- -- Empty

-- -- -- -- -- Set ------------------------------------------------

?let c = oclEmpty(Set(Integer)) in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer)} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

?let c = Bag{1} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

?let c = Sequence{1} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{4} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

?let c = Bag{4} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

?let c = Sequence{4} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer), 1, 2, 3} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, 2, 3, 
                  oclUndefined(Integer)} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, 2, 3} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 2, 3, 
                       oclUndefined(Integer)} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 2, 3} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1, 2, 3} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values

?let c = Bag{1, 2, 3, 1} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 3} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values

?let c = Sequence{1, 2, 3, 1} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 3} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{2, 3, 4, 5} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Bag{2, 3, 4, 5, 4} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Bag{2, 3, 4, 5, 2} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{2, 3, 4, 5} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Sequence{2, 3, 4, 5, 4} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Sequence{2, 3, 4, 5, 2} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{2, 3, 4, 5} in 
   c->forAll(i|i<4) = c->iterate(i;r:Boolean = true|r and i<4)

Expected Results:
  true : Boolean

