-- Collection Operations

-- -- Iterate

-- -- -- one

-- -- -- -- Empty

-- -- -- -- -- Set ------------------------------------------------

?let c = oclEmpty(Set(Integer)) in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
             (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
             (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
             (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer)} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

?let c = Bag{1} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

?let c = Sequence{1} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{4} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

?let c = Bag{4} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

?let c = Sequence{4} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer), 1, 4, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, 4, 5, 
                  oclUndefined(Integer)} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, 4, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 4, 5, 
                       oclUndefined(Integer)} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- No Equal Values

?let c = Sequence{oclUndefined(Integer), 1, 4, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Expression e fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1, 4, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values

?let c = Bag{1, 4, 5, 4} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 4, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values

?let c = Sequence{1, 4, 5, 4} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 4, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- Expression e not fulfilled

-- -- -- -- -- -- -- Set ------------------------------------------

?let c = Set{1, 2, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Bag

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Bag{1, 2, 5, 1} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Bag{1, 2, 5, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, 2, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- -- Equal Values (both violating)

?let c = Sequence{1, 2, 5, 1} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- Equal Values (both not violating)

?let c = Sequence{1, 2, 5, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

-- -- -- -- -- -- -- -- No Equal Values

?let c = Sequence{1, 2, 5} in 
   c->one(i|i<4) = 
     c->iterate(i; r:Sequence(Boolean) = Sequence{false,false} | 
           if r->first() then Sequence{true,false} 
           else Sequence{r->last() and i<4, 
           (r->last() and i<4) xor (r->last() or i<4)} endif)->last()

Expected Results:
  true : Boolean

