-- Technical Relationships

-- -- Singleton to Value

-- -- -- Empty

-- -- -- -- Set ---------------------------------------------------

?let c = oclEmpty(Set(Integer)) in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = oclEmpty(Bag(Integer)) in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- Sequence

?let c = oclEmpty(Sequence(Integer)) in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = oclEmpty(Sequence(Integer)) in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- Singleton

-- -- -- -- Includes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{oclUndefined(Integer)} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer)} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
             if r->at(2) = false then Sequence{elem,true} 
             else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer)} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Sequence{oclUndefined(Integer)} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- Excludes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Set{2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = Bag{2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Bag{2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = Sequence{2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Sequence{2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- Many Elements

-- -- -- -- Includes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{oclUndefined(Integer), 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 2} in 
       if c->size() = 1 then c->any(true) else 
       oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer), 2} in 
       if c->size() = 1 then c->any(true) else 
       oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Bag{oclUndefined(Integer), 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = Sequence{oclUndefined(Integer), 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Sequence{oclUndefined(Integer), 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- Excludes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{1, 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Set{1, 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem;
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Bag

?let c = Bag{1, 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Bag{1, 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

-- -- -- -- -- Sequence

?let c = Sequence{1, 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
         if c->size() = 1 then 
       c->iterate(elem; r:Integer = oclUndefined(Integer) | elem) 
         else oclUndefined(Integer) endif

Expected Results:
  true : Boolean

?let c = Sequence{1, 2} in 
       if c->size() = 1 then c->any(true) 
       else oclUndefined(Integer) endif = 
     c->iterate(elem; 
           r:Sequence(OclAny) = Sequence{oclUndefined(Integer),false} |
           if r->at(2) = false then Sequence{elem,true} 
           else Sequence{oclUndefined(Integer),true} endif)->at(1)

Expected Results:
  true : Boolean

