-- Technical Relationships

-- -- Determinateness Constraints

-- -- -- In Addition to the Ocl4All 2007 equivalences

-- -- -- -- Empty

-- -- -- -- -- Set -----------------------------------------------------

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asBag()->any(true)

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asSequence()->any(true)

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asBag()->asSequence()->any(true)

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asSequence()->first()

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asSequence()->last()

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asBag()->asSequence()->first()

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->asBag()->asSequence()->last()

?let c = oclEmpty(Set(Integer)) in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = oclEmpty(Set(Integer)) in Sequence{c}->flatten() = c->asSequence()

?let c = oclEmpty(Set(Integer)) in Sequence{c}->flatten() = c->asBag()->asSequence()

-- -- -- -- -- Bag

?let c = oclEmpty(Bag(Integer)) in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = oclEmpty(Bag(Integer)) in c->any(true) = c->asSequence()->any(true)

?let c = oclEmpty(Bag(Integer)) in c->any(true) = c->asSequence()->first()

?let c = oclEmpty(Bag(Integer)) in c->any(true) = c->asSequence()->last()

?let c = oclEmpty(Bag(Integer)) in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = oclEmpty(Bag(Integer)) in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- Sequence

-- -- -- -- Singleton

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asBag()->any(true)

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asSequence()->any(true)

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asBag()->asSequence()->any(true)

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asSequence()->first()

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asSequence()->last()

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asBag()->asSequence()->first()

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->asBag()->asSequence()->last()

?let c = Set{oclUndefined(Integer)} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Set{oclUndefined(Integer)} in Sequence{c}->flatten() = c->asSequence()

?let c = Set{oclUndefined(Integer)} in Sequence{c}->flatten() = c->asBag()->asSequence()

-- -- -- -- -- -- Bag

?let c = Bag{oclUndefined(Integer)} in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = Bag{oclUndefined(Integer)} in c->any(true) = c->asSequence()->any(true)

?let c = Bag{oclUndefined(Integer)} in c->any(true) = c->asSequence()->first()

?let c = Bag{oclUndefined(Integer)} in c->any(true) = c->asSequence()->last()

?let c = Bag{oclUndefined(Integer)} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Bag{oclUndefined(Integer)} in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- -- Sequence

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1} in c->any(true) = c->asBag()->any(true)

?let c = Set{1} in c->any(true) = c->asSequence()->any(true)

?let c = Set{1} in c->any(true) = c->asBag()->asSequence()->any(true)

?let c = Set{1} in c->any(true) = c->asSequence()->first()

?let c = Set{1} in c->any(true) = c->asSequence()->last()

?let c = Set{1} in c->any(true) = c->asBag()->asSequence()->first()

?let c = Set{1} in c->any(true) = c->asBag()->asSequence()->last()

?let c = Set{1} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Set{1} in Sequence{c}->flatten() = c->asSequence()

?let c = Set{1} in Sequence{c}->flatten() = c->asBag()->asSequence()

-- -- -- -- -- -- Bag

?let c = Bag{1} in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = Bag{1} in c->any(true) = c->asSequence()->any(true)

?let c = Bag{1} in c->any(true) = c->asSequence()->first()

?let c = Bag{1} in c->any(true) = c->asSequence()->last()

?let c = Bag{1} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Bag{1} in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- -- Sequence

-- -- -- -- Many Elements

-- -- -- -- -- Includes Undefined

-- -- -- -- -- -- Set --------------------------------------------------

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asBag()->any(true)

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->any(true)

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asBag()->asSequence()->any(true)

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->first()

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->last()

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asBag()->asSequence()->first()

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asBag()->asSequence()->last()

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in Sequence{c}->flatten() = c->asSequence()

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in Sequence{c}->flatten() = c->asBag()->asSequence()

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, oclUndefined(Integer)} in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, oclUndefined(Integer)} in c->any(true) = c->asSequence()->any(true)

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, oclUndefined(Integer)} in c->any(true) = c->asSequence()->first()

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, oclUndefined(Integer)} in c->any(true) = c->asSequence()->last()

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, oclUndefined(Integer)} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0, oclUndefined(Integer)} in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->any(true)

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->first()

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->last()

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Bag{oclUndefined(Integer), 1, -1, 3, 2, 0} in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

-- -- -- -- -- -- -- No Equal Values

-- -- -- -- -- Excludes Undefined

-- -- -- -- -- -- Set -----------------------------------------------

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asBag()->any(true)

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->any(true)

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asBag()->asSequence()->any(true)

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->first()

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->last()

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asBag()->asSequence()->first()

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->asBag()->asSequence()->last()

?let c = Set{1, -1, 3, 2, 0} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Set{1, -1, 3, 2, 0} in Sequence{c}->flatten() = c->asSequence()

?let c = Set{1, -1, 3, 2, 0} in Sequence{c}->flatten() = c->asBag()->asSequence()

-- -- -- -- -- -- Bag

-- -- -- -- -- -- -- Equal Values

?let c = Bag{1, -1, 3, 2, 0, 1} in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = Bag{1, -1, 3, 2, 0, 1} in c->any(true) = c->asSequence()->any(true)

?let c = Bag{1, -1, 3, 2, 0, 1} in c->any(true) = c->asSequence()->first()

?let c = Bag{1, -1, 3, 2, 0, 1} in c->any(true) = c->asSequence()->last()

?let c = Bag{1, -1, 3, 2, 0, 1} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Bag{1, -1, 3, 2, 0, 1} in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- -- -- No Equal Values

?let c = Bag{1, -1, 3, 2, 0} in c->asSequence() = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))

?let c = Bag{1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->any(true)

?let c = Bag{1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->first()

?let c = Bag{1, -1, 3, 2, 0} in c->any(true) = c->asSequence()->last()

?let c = Bag{1, -1, 3, 2, 0} in c->any(true) = c->iterate(elem;r:Sequence(Integer) = oclEmpty(Sequence(Integer))|r->including(elem))->first()

?let c = Bag{1, -1, 3, 2, 0} in Sequence{c}->flatten() = c->asSequence()

-- -- -- -- -- -- Sequence

-- -- -- -- -- -- -- Equal Values

-- -- -- -- -- -- -- No Equal Values

