-- Technical Relationships

-- -- Conversion to Sequences

-- -- -- Empty

-- -- -- -- Set ---------------------------------------------------

?let c = oclEmpty(Set(Integer)) in 
   c->asSequence() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in 
   c->asSequence() = 
     c->iterate(elem; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) | 
           r->including(elem))

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in 
   c->asSequence() = 
     c->iterate(u;
           r:Tuple(theSet:Set(Integer), theSeq:Sequence(Integer)) = 
             Tuple{theSet:c,theSeq:oclEmpty(Sequence(Integer))} | 
           let e = r.theSet->any(true) in 
             Tuple{theSet:r.theSet->excluding(e),
                   theSeq:r.theSeq->including(e)}).theSeq

Expected Results:
  true : Boolean

?let c = oclEmpty(Set(Integer)) in 
   c->asSequence() = Sequence{c}->flatten()

Expected Results:
  true : Boolean

-- -- -- Singleton

-- -- -- -- Includes Undefined

-- -- -- -- -- Set ------------------------------------------------

?let c = Set{oclUndefined(Integer)} in 
   c->asSequence() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in 
   c->asSequence() = 
     c->iterate(elem; 
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in 
   c->asSequence() = 
     c->iterate(u;
           r:Tuple(theSet:Set(Integer),theSeq:Sequence(Integer)) = 
             Tuple{theSet:c,theSeq:oclEmpty(Sequence(Integer))} |
           let e = r.theSet->any(true) in 
             Tuple{theSet:r.theSet->excluding(e),
                   theSeq:r.theSeq->including(e)}).theSeq

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer)} in 
   c->asSequence() = Sequence{c}->flatten()

Expected Results:
  true : Boolean

-- -- -- -- Excludes Undefined

-- -- -- -- -- Set ---------------------------------------------

?let c = Set{1} in c->asSequence() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

?let c = Set{1} in 
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Set{1} in 
   c->asSequence() = 
     c->iterate(u;
           r:Tuple(theSet:Set(Integer),theSeq:Sequence(Integer)) = 
             Tuple{theSet:c,theSeq:oclEmpty(Sequence(Integer))} |
           let e = r.theSet->any(true) in 
             Tuple{theSet:r.theSet->excluding(e),
                   theSeq:r.theSeq->including(e)}).theSeq

Expected Results:
  true : Boolean

?let c = Set{1} in c->asSequence() = Sequence{c}->flatten()

Expected Results:
  true : Boolean

-- -- -- Many Elements

-- -- -- -- Includes Undefined

-- -- -- -- -- Set ---------------------------------------------

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in 
   c->asSequence() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in 
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in 
   c->asSequence() = 
     c->iterate(u;
           r:Tuple(theSet:Set(Integer),theSeq:Sequence(Integer)) = 
             Tuple{theSet:c,theSeq:oclEmpty(Sequence(Integer))} |
           let e = r.theSet->any(true) in 
             Tuple{theSet:r.theSet->excluding(e),
                   theSeq:r.theSeq->including(e)}).theSeq

Expected Results:
  true : Boolean

?let c = Set{oclUndefined(Integer), 1, -1, 3, 2, 0} in 
   c->asSequence() = Sequence{c}->flatten()

Expected Results:
  true : Boolean

-- -- -- -- Excludes Undefined

-- -- -- -- -- Set ---------------------------------------------

?let c = Set{1, -1, 3, 2, 0} in 
   c->asSequence() = c->asBag()->asSequence()

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in 
   c->asSequence() = 
     c->iterate(elem;
                    r:Sequence(Integer) = oclEmpty(Sequence(Integer)) |
           r->including(elem))

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in 
   c->asSequence() = 
     c->iterate(u;
           r:Tuple(theSet:Set(Integer),theSeq:Sequence(Integer)) = 
             Tuple{theSet:c,theSeq:oclEmpty(Sequence(Integer))} |
           let e = r.theSet->any(true) in 
             Tuple{theSet:r.theSet->excluding(e),
                   theSeq:r.theSeq->including(e)}).theSeq

Expected Results:
  true : Boolean

?let c = Set{1, -1, 3, 2, 0} in 
   c->asSequence() = Sequence{c}->flatten()

Expected Results:
  true : Boolean

